Linux Kernel Selftest development
 help / color / mirror / Atom feed
From: mhiramat at kernel.org (Masami Hiramatsu)
Subject: [PATCH v5 04/19] selftests: ftrace: Add a testcase for probepoint
Date: Thu,  8 Mar 2018 17:45:32 +0900	[thread overview]
Message-ID: <152049873256.7289.3073863568299389050.stgit@devbox> (raw)
In-Reply-To: <152049860385.7289.14079393589900496424.stgit@devbox>

Add a testcase for probe point definition. This tests
symbol, address and symbol+offset syntax. The offset
must be positive and smaller than UINT_MAX.

Signed-off-by: Masami Hiramatsu <mhiramat at kernel.org>
---
 .../selftests/ftrace/test.d/kprobe/probepoint.tc   |   43 ++++++++++++++++++++
 1 file changed, 43 insertions(+)
 create mode 100644 tools/testing/selftests/ftrace/test.d/kprobe/probepoint.tc

diff --git a/tools/testing/selftests/ftrace/test.d/kprobe/probepoint.tc b/tools/testing/selftests/ftrace/test.d/kprobe/probepoint.tc
new file mode 100644
index 000000000000..4fda01a08da4
--- /dev/null
+++ b/tools/testing/selftests/ftrace/test.d/kprobe/probepoint.tc
@@ -0,0 +1,43 @@
+#!/bin/sh
+# SPDX-License-Identifier: GPL-2.0
+# description: Kprobe events - probe points
+
+[ -f kprobe_events ] || exit_unsupported # this is configurable
+
+TARGET_FUNC=create_trace_kprobe
+
+dec_addr() { # hexaddr
+  printf "%d" "0x"`echo $1 | tail -c 8`
+}
+
+set_offs() { # prev target next
+  A1=`dec_addr $1`
+  A2=`dec_addr $2`
+  A3=`dec_addr $3`
+  TARGET="0x$2" # an address
+  PREV=`expr $A1 - $A2` # offset to previous symbol
+  NEXT=+`expr $A3 - $A2` # offset to next symbol
+  OVERFLOW=+`printf "0x%x" ${PREV}` # overflow offset to previous symbol
+}
+
+# We have to decode symbol addresses to get correct offsets.
+# If the offset is not an instruction boundary, it cause -EILSEQ.
+set_offs `grep -A1 -B1 ${TARGET_FUNC} /proc/kallsyms | cut -f 1 -d " " | xargs`
+
+UINT_TEST=no
+# printf "%x" -1 returns (unsigned long)-1.
+if [ `printf "%x" -1 | wc -c` != 9 ]; then
+  UINT_TEST=yes
+fi
+
+echo 0 > events/enable
+echo > kprobe_events
+echo "p:testprobe ${TARGET_FUNC}" > kprobe_events
+echo "p:testprobe ${TARGET}" > kprobe_events
+echo "p:testprobe ${TARGET_FUNC}${NEXT}" > kprobe_events
+! echo "p:testprobe ${TARGET_FUNC}${PREV}" > kprobe_events
+if [ "${UINT_TEST}" = yes ]; then
+! echo "p:testprobe ${TARGET_FUNC}${OVERFLOW}" > kprobe_events
+fi
+echo > kprobe_events
+clear_trace

--
To unsubscribe from this list: send the line "unsubscribe linux-kselftest" in
the body of a message to majordomo at vger.kernel.org
More majordomo info at  http://vger.kernel.org/majordomo-info.html

WARNING: multiple messages have this Message-ID (diff)
From: mhiramat@kernel.org (Masami Hiramatsu)
Subject: [PATCH v5 04/19] selftests: ftrace: Add a testcase for probepoint
Date: Thu,  8 Mar 2018 17:45:32 +0900	[thread overview]
Message-ID: <152049873256.7289.3073863568299389050.stgit@devbox> (raw)
Message-ID: <20180308084532.aHLXx1I70HEGR0ePZ0OZ6vM87FlM6KMCM4GRD5qRe20@z> (raw)
In-Reply-To: <152049860385.7289.14079393589900496424.stgit@devbox>

Add a testcase for probe point definition. This tests
symbol, address and symbol+offset syntax. The offset
must be positive and smaller than UINT_MAX.

Signed-off-by: Masami Hiramatsu <mhiramat at kernel.org>
---
 .../selftests/ftrace/test.d/kprobe/probepoint.tc   |   43 ++++++++++++++++++++
 1 file changed, 43 insertions(+)
 create mode 100644 tools/testing/selftests/ftrace/test.d/kprobe/probepoint.tc

diff --git a/tools/testing/selftests/ftrace/test.d/kprobe/probepoint.tc b/tools/testing/selftests/ftrace/test.d/kprobe/probepoint.tc
new file mode 100644
index 000000000000..4fda01a08da4
--- /dev/null
+++ b/tools/testing/selftests/ftrace/test.d/kprobe/probepoint.tc
@@ -0,0 +1,43 @@
+#!/bin/sh
+# SPDX-License-Identifier: GPL-2.0
+# description: Kprobe events - probe points
+
+[ -f kprobe_events ] || exit_unsupported # this is configurable
+
+TARGET_FUNC=create_trace_kprobe
+
+dec_addr() { # hexaddr
+  printf "%d" "0x"`echo $1 | tail -c 8`
+}
+
+set_offs() { # prev target next
+  A1=`dec_addr $1`
+  A2=`dec_addr $2`
+  A3=`dec_addr $3`
+  TARGET="0x$2" # an address
+  PREV=`expr $A1 - $A2` # offset to previous symbol
+  NEXT=+`expr $A3 - $A2` # offset to next symbol
+  OVERFLOW=+`printf "0x%x" ${PREV}` # overflow offset to previous symbol
+}
+
+# We have to decode symbol addresses to get correct offsets.
+# If the offset is not an instruction boundary, it cause -EILSEQ.
+set_offs `grep -A1 -B1 ${TARGET_FUNC} /proc/kallsyms | cut -f 1 -d " " | xargs`
+
+UINT_TEST=no
+# printf "%x" -1 returns (unsigned long)-1.
+if [ `printf "%x" -1 | wc -c` != 9 ]; then
+  UINT_TEST=yes
+fi
+
+echo 0 > events/enable
+echo > kprobe_events
+echo "p:testprobe ${TARGET_FUNC}" > kprobe_events
+echo "p:testprobe ${TARGET}" > kprobe_events
+echo "p:testprobe ${TARGET_FUNC}${NEXT}" > kprobe_events
+! echo "p:testprobe ${TARGET_FUNC}${PREV}" > kprobe_events
+if [ "${UINT_TEST}" = yes ]; then
+! echo "p:testprobe ${TARGET_FUNC}${OVERFLOW}" > kprobe_events
+fi
+echo > kprobe_events
+clear_trace

--
To unsubscribe from this list: send the line "unsubscribe linux-kselftest" in
the body of a message to majordomo at vger.kernel.org
More majordomo info at  http://vger.kernel.org/majordomo-info.html

  parent reply	other threads:[~2018-03-08  8:45 UTC|newest]

Thread overview: 50+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2018-03-08  8:43 [PATCH v5 00/19] tracing: probeevent: Improve fetcharg features mhiramat
2018-03-08  8:43 ` Masami Hiramatsu
2018-03-08  8:44 ` [PATCH v5 01/19] [BUGFIX] tracing: probeevent: Fix to support minus offset from symbol mhiramat
2018-03-08  8:44   ` Masami Hiramatsu
2018-03-08  8:44 ` [PATCH v5 02/19] selftests: ftrace: Add probe event argument syntax testcase mhiramat
2018-03-08  8:44   ` Masami Hiramatsu
2018-03-08  8:45 ` [PATCH v5 03/19] selftests: ftrace: Add a testcase for string type with kprobe_event mhiramat
2018-03-08  8:45   ` Masami Hiramatsu
2018-03-08  8:45 ` mhiramat [this message]
2018-03-08  8:45   ` [PATCH v5 04/19] selftests: ftrace: Add a testcase for probepoint Masami Hiramatsu
2018-03-08  8:46 ` [PATCH v5 05/19] tracing: probeevent: Cleanup print argument functions mhiramat
2018-03-08  8:46   ` Masami Hiramatsu
2018-03-08  8:46 ` [PATCH v5 06/19] tracing: probeevent: Cleanup argument field definition mhiramat
2018-03-08  8:46   ` Masami Hiramatsu
2018-03-08  8:46 ` [PATCH v5 07/19] tracing: probeevent: Remove NOKPROBE_SYMBOL from print functions mhiramat
2018-03-08  8:46   ` Masami Hiramatsu
2018-03-08  8:47 ` [PATCH v5 08/19] tracing: probeevent: Introduce new argument fetching code mhiramat
2018-03-08  8:47   ` Masami Hiramatsu
2018-03-08  8:47 ` [PATCH v5 09/19] tracing: probeevent: Unify fetch type tables mhiramat
2018-03-08  8:47   ` Masami Hiramatsu
2018-03-08  8:47 ` [PATCH v5 10/19] tracing: probeevent: Return consumed bytes of dynamic area mhiramat
2018-03-08  8:47   ` Masami Hiramatsu
2018-03-08  8:48 ` [PATCH v5 11/19] tracing: probeevent: Append traceprobe_ for exported function mhiramat
2018-03-08  8:48   ` Masami Hiramatsu
2018-03-08  8:48 ` [PATCH v5 12/19] tracing: probeevent: Unify fetch_insn processing common part mhiramat
2018-03-08  8:48   ` Masami Hiramatsu
2018-03-08  8:49 ` [PATCH v5 13/19] tracing: probeevent: Add symbol type mhiramat
2018-03-08  8:49   ` Masami Hiramatsu
2018-03-08  8:49 ` [PATCH v5 14/19] x86: ptrace: Add function argument access API mhiramat
2018-03-08  8:49   ` Masami Hiramatsu
2018-03-08  8:50 ` [PATCH v5 15/19] tracing: probeevent: Add $argN for accessing function args mhiramat
2018-03-08  8:50   ` Masami Hiramatsu
2018-03-08  8:50 ` [PATCH v5 16/19] tracing: probeevent: Add array type support mhiramat
2018-03-08  8:50   ` Masami Hiramatsu
2018-03-15  5:48   ` ravi.bangoria
2018-03-15  5:48     ` Ravi Bangoria
2018-03-15  7:18     ` mhiramat
2018-03-15  7:18       ` Masami Hiramatsu
2018-03-15  7:23       ` mhiramat
2018-03-15  7:23         ` Masami Hiramatsu
2018-03-15  8:01         ` ravi.bangoria
2018-03-15  8:01           ` Ravi Bangoria
2018-03-16 14:48   ` mhiramat
2018-03-16 14:48     ` Masami Hiramatsu
2018-03-08  8:51 ` [PATCH v5 17/19] selftests: ftrace: Add a testcase for symbol type mhiramat
2018-03-08  8:51   ` Masami Hiramatsu
2018-03-08  8:51 ` [PATCH v5 18/19] selftests: ftrace: Add a testcase for $argN with kprobe_event mhiramat
2018-03-08  8:51   ` Masami Hiramatsu
2018-03-08  8:52 ` [PATCH v5 19/19] selftests: ftrace: Add a testcase for array type " mhiramat
2018-03-08  8:52   ` Masami Hiramatsu

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=152049873256.7289.3073863568299389050.stgit@devbox \
    --to=linux-kselftest@vger.kernel.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox